import { OperationResult } from "./class/Operation.class";
import { PolicyCallback } from "./policies";
/**
 * Those options are inspired by the retry package
 * @see https://www.npmjs.com/package/retry
 */
export interface RetryOptions {
    retries?: number;
    minTimeout?: number;
    maxTimeout?: number;
    unref?: boolean;
    factor?: number;
    forever?: boolean;
    signal?: AbortSignal | null;
}
export declare type RetryCallback<T> = (() => Promise<T>) | (() => T);
export declare function retry<T>(callback: RetryCallback<T>, options?: RetryOptions, policy?: PolicyCallback): Promise<OperationResult<T>>;
