"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stream = exports.pipeline = void 0;
// Import Third-party Dependencies
const undici = __importStar(require("undici"));
const agents_1 = require("./agents");
const Utils = __importStar(require("./utils"));
function pipeline(method, uri, options = {}) {
    var _a, _b;
    const { maxRedirections = 0 } = options;
    const computedURI = (0, agents_1.computeURI)(uri);
    if (typeof options.querystring !== "undefined") {
        const qs = typeof options.querystring === "string" ? new URLSearchParams(options.querystring) : options.querystring;
        for (const [key, value] of qs.entries()) {
            computedURI.url.searchParams.set(key, value);
        }
    }
    const dispatcher = (_b = (_a = options.agent) !== null && _a !== void 0 ? _a : computedURI.agent) !== null && _b !== void 0 ? _b : void 0;
    const headers = Utils.createHeaders({ headers: options.headers, authorization: options.authorization });
    const body = Utils.createBody(options.body, headers);
    return undici.pipeline(computedURI.url, {
        method, headers, body, dispatcher, maxRedirections
    }, ({ body }) => body);
}
exports.pipeline = pipeline;
function stream(method, uri, options = {}) {
    var _a, _b;
    const { maxRedirections = 0 } = options;
    const computedURI = (0, agents_1.computeURI)(uri);
    const dispatcher = (_b = (_a = options.agent) !== null && _a !== void 0 ? _a : computedURI.agent) !== null && _b !== void 0 ? _b : void 0;
    const headers = Utils.createHeaders({ headers: options.headers, authorization: options.authorization });
    const body = Utils.createBody(options.body, headers);
    return (writable) => undici
        .stream(computedURI.url, { method, headers, body, dispatcher, maxRedirections }, () => writable);
}
exports.stream = stream;
//# sourceMappingURL=stream.js.map