import { Nsci } from "../standard/index.js";
import { ExternalRuntimeConfiguration } from "./common.js";
/**
 * In the first place, we need to adapt options from either the CLI, the API or
 * the NodeSecure runtime config file in order to be used as a Nsci.Configuration
 * acting as a standard runtime config format.
 * This adapt takes into account name bindings but also checks validity of values
 * that were supplied from the external world (NodeSecure RC, API, CLI)
 * (e.g: validate severity threshold supplied)
 */
export declare function adaptExternalToStandardConfiguration(sanitizedOptions: Partial<ExternalRuntimeConfiguration>): Partial<Nsci.Configuration>;
